:
# bltn_so.sh - build a new shared library (icbltn.so) with the given objects
#

if [ $# -lt 1 ]; then
   echo "At least one argument is required!"
   echo "    arg1 = .o module"
   exit 1
fi

case `uname -s` in
    Darwin)
        ld -o icbltn.dylib -dylib -arch i386 $@ -lc
        ;;
    Linux)
        ld -o icbltn.so -shared -Bdynamic -h icbltn.so $@ -lc
        ;;
    *)
        echo "Cannot build icbltn.so for target "
        ;;
esac

