 SETVAL.
***********************************************************
* THIS PARAGRAPH CAN BE INCLUDED IN ANY PROGRAM NEEDING   *
* TO RESET THE INITIAL VALUE FOR A FIELD.  THIS INITIAL   *
* VALUE IS IMPORTANT BECAUSE IT IS USED FOR A VARIETY OF  *
* DIFFERENT PURPOSES, IN PARTICULAR:                      *
* - LIST OF ENTRIES FOR A COMBOBOX                        *
* - LIST OF ENTRIES FOR A LISTBOX                         *
* - BITMAPS TO BE DISPLAYED FOR AN ICON                   * 
* BEFORE PERFORMING THE PARAGRAPH:                        *
* 1. COPY "SP2.CPY" INTO WORKING-STORAGE                  * 
* 2. COPY "SETVALWS.CPY" INTO WORKING-STORAGE             *
* 3. DEFINE ITEM CALLED SETVAL-DATA CONTAINING NEW VALUE  *
* 4. OPEN A WINDOW FOR THE PANEL CONTAINING THE FIELD     *
* 5. SET SETVAL-ID TO ID OF FIELD                         *
* 6. SET SETVAL-LEN TO LENGTH OF NEW VALUE                *
***********************************************************
     MOVE 2000 TO SP2-FD-VAR-LEN.
     MOVE LOW-VALUES TO SP2-FD-VAR-LENS.
     MOVE LOW-VALUES TO SP2-FD-DATA.               
     MOVE SETVAL-ID TO SP2-FD-ID.
     CALL "SP2" USING SP2-GET-FIELD-DEF SP2-FIELD-DEF.
     COMPUTE SETVAL-1 = SP2-FD-FORMAT-LEN 
                                + SP2-FD-CAPTION-LEN + 1.
     COMPUTE SETVAL-2 = SP2-FD-RANGE-LEN + SP2-FD-DISCRETE-LEN
       + SP2-FD-MSG-TEXT-LEN + SP2-FD-USER-LEN + SP2-FD-HELP-LEN.
     IF SETVAL-2 GREATER THAN 0
         ADD SP2-FD-INITIAL-LEN TO SETVAL-1
         MOVE SP2-FD-VAR-DATA (SETVAL-1 : SETVAL-2) 
                                         TO SETVAL-SAVE 
         SUBTRACT SP2-FD-INITIAL-LEN FROM SETVAL-1.
     SUBTRACT SP2-FD-INITIAL-LEN FROM SP2-FD-VAR-LEN.
     MOVE SETVAL-LEN TO SP2-FD-INITIAL-LEN.
     ADD SP2-FD-INITIAL-LEN TO SP2-FD-VAR-LEN.
     MOVE SETVAL-DATA 
            TO SP2-FD-VAR-DATA (SETVAL-1 : SP2-FD-INITIAL-LEN).
     IF SETVAL-2 GREATER THAN 0
         ADD SP2-FD-INITIAL-LEN TO SETVAL-1
         MOVE SETVAL-SAVE (1 : SETVAL-2) 
                         TO SP2-FD-VAR-DATA (SETVAL-1 : SETVAL-2).
     CALL "SP2" USING SP2-SET-FIELD-DEF SP2-FIELD-DEF.
